#!/usr/bin/ruby -Ks
#
#  YKLook
#        Copyright (C) 2009-2010 YorozuKotowariYa Ltd.

if ARGV.size() != 1
	STDERR.puts("need a filename")
	exit
end

YK_FUNCDSP = "NXꗗi@\ʁENXKw\j"
YK_FUNC    = "@\"
YK_LIST    = 'y[WNꗗ'
YK_LIST_C  = 'y[WNꗗF'
YK_SUPER   = 'X[p[NX'
YK_SUPER_C = 'X[p[NXF'
YK_CLASS   = 'NX\bh'
YK_CLASS_C = 'NX\bhF'
YK_INST    = 'CX^X\bh'
YK_INST_C  = 'CX^X\bhF'
YK_MISC    = '̑̍'
YK_MISC_C  = '̑̍ځF'
YK_DIGIT   = ['O','P','Q','R','S','T','U','V','W','X']

#
# methods
#
def mDeleteTrail( prmLines )
	idx = 0
	while idx < prmLines.size()
		if prmLines[idx] == "ȏ\n"
			break
		end
		idx += 1
	end
	while idx < prmLines.size()
		prmLines.delete_at( idx )
	end
end

def mScan( prmLines )
	hash = { ':class' => [], ':instance' => [], ':misc' => [] }
	idx = 0
	while idx < prmLines.size()
		cm = prmLines[idx].index( YK_CLASS_C )
		if cm and cm == 0
			break
		end
		idx += 1
	end
	if idx >= prmLines.size()
		STDERR.puts('class method, not found')
		exit
	end
	idx += 1

	#
	# class method
	#
	idxOld = 0
	seqOld = -2
	tokOld = '-/*@:;.,'
	ary    = hash[':class']
	while idx < prmLines.size()
		str = prmLines[idx]
		cm = str.index( YK_INST_C )
		if cm and cm == 0
			break
		end
		# class method
		if str.size() >= 1
			if str[0] != 0x09 and str[0] != 0x0d and str[0] != 0x0a
				if str.size() < 4
					STDERR.puts('ill-fmt size at class method')
					exit
				end
				slice = mSliceTokenIgnoreBlank( str )
				chr = slice[0][0]
				seq = (0x30 <= chr and chr <= 0x39) ? slice[0].to_i() : -1
				tno = (seq < 0 ? 0 : 1)
				tok = slice[ tno ]
				if (idxOld + 1) == idx and tokOld != '@'
					if seq != seqOld
						STDERR.puts('ill-fmt seq at class method')
						exit
					end
					if tok != tokOld
						STDERR.puts('ill-fmt tok at class method')
						exit
					end
				else
					num = nil
					case (seq < 0 ? str[0..1] : tok[0..1])
					when '@(' then
						if seq != -1
							STDERR.puts('ill-fmt label seq at class method')
							exit
						end
						k = str.index(')')
						if not k
							STDERR.puts('ill-fmt label end at class method')
							exit
						end
						if (idx + 1) >= prmLines.size()
							STDERR.puts('ill-fmt label next 1 at class method')
							exit
						end
						chr = prmLines[idx+1][0]
						if chr == 0x20 or chr == 0x09 or
							chr == 0x0d or chr == 0x0a
							STDERR.puts('ill-fmt label next 2 at class method')
							exit
						end
						if chr == 0x81 and prmLines[idx+1][1] == 0x40
							STDERR.puts('ill-fmt label next 3 at class method')
							exit
						end
						key = '@' + str[2...k]
						val = key
					when 'ne'
						if tok != 'new'
							STDERR.puts('ill-fmt new at class method')
							exit
						end
						key = '.' + mJoinIgnoreBlank(slice,tno)
						num = (seq < 0 ? '1' : seq.to_s())
						val = 'c-' + tok + '-' + num
					when 'yk'
						if tok[2..2] != '_'
							STDERR.puts('ill-fmt yk at class method')
							STDERR.puts('idx=' + idx.to_s())
							STDERR.puts('str=' + str.to_s())
							exit
						end
						key = '.' + mJoinIgnoreBlank(slice,tno)
						num = (seq < 0 ? '1' : seq.to_s())
						val = 'c-' + tok + '-' + num
					else
						STDERR.puts('ill-fmt @/ne/yk at class method')
						STDERR.puts('idx=' + idx.to_s())
						STDERR.puts('str=' + str.to_s())
						exit
					end
					if hash.has_key?( key )
						STDERR.puts('ill-fmt dup key at class method')
						STDERR.puts('key=' + key.to_s())
						STDERR.puts('val=' + val.to_s())
						exit
					end
					hash[key] = val
					if num
						ary << key
						if num == '1'
							key = '.' + tok
							if hash.has_key?( key )
								STDERR.puts('ill-fmt dup key 1 at class method')
								exit
							end
							hash[key] = val
						end
					end
				end
				seqOld = seq
				tokOld = tok
				idxOld = idx
			end
		end
		idx += 1
	end
	if idx >= prmLines.size()
		STDERR.puts('instance method, not found')
		exit
	end
	idx += 1

	#
	# instance method
	#
	idxOld = 0
	seqOld = -2
	tokOld = '-/*@:;.,'
	ary    = hash[':instance']
	while idx < prmLines.size()
		str = prmLines[idx]
		cm = str.index( YK_MISC_C )
		if cm and cm == 0
			break
		end
		# instance method
		if str.size() >= 1
			if str[0] != 0x09 and str[0] != 0x0d and str[0] != 0x0a
				if str.size() < 4
					STDERR.puts('ill-fmt size at instance method')
					exit
				end
				slice = mSliceTokenIgnoreBlank( str )
				chr = slice[0][0]
				seq = (0x30 <= chr and chr <= 0x39) ? slice[0].to_i() : -1
				tno = (seq < 0 ? 0 : 1)
				tok = slice[ tno ]
				if (idxOld + 1) == idx and tokOld != '@'
					if seq != seqOld
						STDERR.puts('ill-fmt seq at instance method')
						exit
					end
					if tok != tokOld
						STDERR.puts('ill-fmt tok at instance method')
						STDERR.puts('tok=(' + tok.to_s() + ') ' + idx.to_s())
						STDERR.puts('tokOld=(' + tokOld.to_s() + ')')
						exit
					end
				else
					num = nil
					case (seq < 0 ? str[0..1] : tok[0..1])
					when '@(' then
						if seq != -1
							STDERR.puts('ill-fmt label seq at instance method')
							exit
						end
						k = str.index(')')
						if not k
							STDERR.puts('ill-fmt label end at instance method')
							exit
						end
						if (idx + 1) >= prmLines.size()
							STDERR.puts('ill-fmt label next 1 at inst method')
							exit
						end
						chr = prmLines[idx+1][0]
						if chr == 0x20 or chr == 0x09 or
							chr == 0x0d or chr == 0x0a
							STDERR.puts('ill-fmt label next 2 at inst method')
							exit
						end
						if chr == 0x81 and prmLines[idx+1][1] == 0x40
							STDERR.puts('ill-fmt label next 3 at inst method')
							exit
						end
						key = '@' + str[2...k]
						val = key
					when 'yk'
						if tok[2..2] != '_' and tok[2..3] != 'i_'
							STDERR.puts('ill-fmt yk at instance method')
							exit
						end
						key = '#' + mJoinIgnoreBlank(slice,tno)
						num = (seq < 0 ? '1' : seq.to_s())
						val = 'i-' + tok + '-' + num
					else
						STDERR.puts('ill-fmt @/ne/yk at instance method')
						STDERR.puts('idx=' + idx.to_s())
						STDERR.puts('str=' + str.to_s())
						STDERR.puts('tok=' + tok.to_s())
						exit
					end
					if hash.has_key?( key )
						STDERR.puts('ill-fmt dup key at instance method')
						exit
					end
					hash[key] = val
					if num
						ary << key
						if num == '1'
							key = '#' + tok
							if hash.has_key?( key )
								STDERR.puts('ill-fmt dup key 1 at inst method')
								exit
							end
							hash[key] = val
						end
					end
				end
				seqOld = seq
				tokOld = tok
				idxOld = idx
			end
		end
		idx += 1
	end

	idx += 1

	#
	# misc
	#
	idxOld = 0
	key    = nil
	ary    = hash[':misc']
	while idx < prmLines.size()
		# misc
		str = prmLines[idx]
		if str.size() >= 1
			if str[0] != 0x09 and str[0] != 0x0d and str[0] != 0x0a
				if str[0] == 0x20
					STDERR.puts('ill-fmt 0x20 at misc')
					exit
				end
				if str.size() < 4
					STDERR.puts('ill-fmt size at misc')
					exit
				end
				if str[0] == 0x81 and str[1] == 0x40
					STDERR.puts('ill-fmt 0x8140 at misc')
					exit
				end
				if str[0,1] == '@'
					if (idxOld + 1) >= idx
						STDERR.puts('ill-fmt dup label at misc')
						exit
					end
					key = '@' + mGetLabel( str )
					val = key
					if hash.has_key?( key )
						STDERR.puts('ill-fmt dup key at misc')
						exit
					end
					hash[key] = val
					idxOld = idx
				else
					if (idxOld + 1) != idx
						STDERR.puts('ill-fmt miss label at misc')
						exit
					end
					if not hash.has_key?( key )
						STDERR.puts('ill-fmt no key at misc')
						exit
					end
					hash[key] = mTrimBlank( str )
					ary << key
				end
			end
		end
		idx += 1
	end
	return hash
end
def mGetLabel( prmString )
	if prmString[0..1] != '@('
		STDERR.puts('ill-fmt @() first at misc label')
		exit
	end
	pos = prmString.index(')')
	if not pos
		STDERR.puts('ill-fmt @() second at misc label')
		exit
	end
	return prmString[2...pos]
end

def mAddBrIfNeed( prmSlice )
	if prmSlice.size() < 1
		prmSlice << "<br />\n"
	end
	if prmSlice.size() == 1
		str = prmSlice[0]
		if str.size() < 1
			prmSlice[0] = "<br />\n"
		end
	end
	if prmSlice.size() >= 1
		str = mMakeBrIfNeed( prmSlice[-1] )
		if str.size() >= 1
			prmSlice << str
		end
	end
end
def mMakeBrIfNeed( prmString )
	if prmString.size() >= 2
		if prmString[-2..-1] == 'B' or prmString[-2..-1] == 'F'
			return "<br />\n"
		end
	end
	if prmString.size() >= 3
		if prmString[-3..-1] == "B\n" or prmString[-3..-1] == "F\n"
			return "<br />\n"
		end
	end
	return ''
end
def mMakeCodeVarTtLink( prmClassName, prmSlice, prmVarList, prmLinkHash )
	ary = []
	lnk = false
	idx = 0
	while idx < prmSlice.size()
		str = mEscapeHtml( prmSlice[idx] )
		if str[0] < 0x0080
			case str
			when '@(' then
				if lnk
					STDERR.puts('already linked')
					exit
				end
				lnk = true
				if prmSlice[idx+1][0,1] == '='
					str = '<a href="' + prmSlice[idx+1][1..-1] + '">'
				else
					if not prmLinkHash.has_key?( '@' + prmSlice[idx+1] )
						STDERR.puts('unknown link-label')
						exit
					end
					str = '<a href="#' + prmSlice[idx+1] + '">'
				end
				idx += 2
			when '@(@)' then
				if not lnk
					STDERR.puts('not linked')
					exit
				end
				lnk = false
				str = '</a>'
			else
				str = mCodeVarTtLink( prmClassName, str, lnk,
										prmVarList, prmLinkHash )
			end
		end
		ary << str
		idx += 1
	end
	return mJoinZenHan( ary )
end
def mCodeVarTtLink( prmClassName, prmSource,prmLinked, prmVarList, prmLinkHash )
	tokens = mSliceToken( prmSource )
	idxClass  = tokens[0].index( 'YK' )
	idxMethod = tokens[0].index( 'yk_' )
	if not idxMethod
		idxMethod = tokens[0].index( 'yki_' )
		if not idxMethod
			if tokens[0] == 'new'
				idxMethod = 0
			end
		end
	end
	if idxClass and idxClass == 0 and tokens[0] != 'YKLook'
		if prmLinked
			return mCodeVar( tokens )
		end
		if tokens[0][0..5] == 'YKLook' and tokens[0][-2..-1] != 'xx'
			return mCodeVarLinkToOtherClass( prmClassName, tokens, prmVarList )
		end
	end
	if idxMethod and idxMethod == 0 and tokens[0][-1..-1] != '_'
		if prmLinked
			return mCodeVar( tokens )
		end
		return mCodeVarLinkToMyClass( tokens, prmVarList, prmLinkHash )
	end
	tokens.unshift( '<tt> ' )
	tokens << ' </tt>'
	mVar( tokens, prmVarList )
	return tokens.join('')
end
def mCodeVar( prmTokens )
	prmTokens.unshift( '<code> ' )
	prmTokens << ' </code>'
	mVarAny( prmTokens )
	return prmTokens.join('')
end
def mCodeVarLinkToOtherClass( prmClassName, prmTokens, prmVarList )
	idx = mNextIgnoreBlank( prmTokens, 1 )
	if idx < 0  # class name only
		if prmTokens[0] == prmClassName
			return '<code> ' + prmTokens[0] + ' </code>'
		end
		return '<a href="cla-' + prmTokens[0] +
				'.html"> <code> ' + prmTokens[0] + ' </code> </a>'
	end
	met = mNextIgnoreBlank( prmTokens, idx+1 )
	if met < 0
		STDERR.puts('ill-YK-class-method')
		exit
	end
	case prmTokens[idx]
	when '.' then m = 'c'
	when '#' then m = 'i'
	else
		STDERR.puts('ill-YK-class-fmt')
		exit
	end
	str = '<a href="cla-' + prmTokens[0] + '.html#' +
			m + '-' + prmTokens[met] + '-1"> <code> '
	prmTokens.unshift( str )
	prmTokens << ' </code> </a>'
	mVarAny( prmTokens )
	return prmTokens.join('')
end
def mCodeVarLinkToMyClass( prmTokens, prmVarList, prmLinkHash )
	metNam = mJoinIgnoreBlank( prmTokens )
	refCls = prmLinkHash[ '.' + metNam ]
	refIns = prmLinkHash[ '#' + metNam ]
	# if refCls and refIns
	#	STDERR.puts('dup-method-1 ' + metNam )
	#	exit
	# end
	ref = nil
	ref = refCls ? refCls : ref
	ref = refIns ? refIns : ref
	if not ref
		refCls = prmLinkHash[ '.' + prmTokens[0] ]
		refIns = prmLinkHash[ '#' + prmTokens[0] ]
		if refCls and refIns
			STDERR.puts('dup-method-2 ' + metNam )
			exit
		end
		ref = refCls ? refCls : ref
		ref = refIns ? refIns : ref
		if not ref
			STDERR.puts('ill-method-name ' + metNam)
			exit
		end
	end
	str = '<a href="#' + ref + '"> <code> '
	prmTokens.unshift( str )
	prmTokens << ' </code> </a>'
	mVarAny( prmTokens )
	return prmTokens.join('')
end
def mVar( prmTokens, prmVarList )
	idx = 0
	while idx < prmTokens.size()
		if prmVarList.include?( prmTokens[idx] )
			prmTokens[idx] = '<var> ' + prmTokens[idx] + ' </var>'
		end
		idx += 1
	end
end
def mVarAny( prmTokens )
	flg = 0
	idx = 0
	while idx < prmTokens.size()
		case prmTokens[idx]
		when '(' then flg = 1
		when ')' then flg = 0
		when ',' then flg = flg
		else
			if flg == 1
				prmTokens[idx] = '<var> ' + prmTokens[idx] + ' </var>'
			end
		end
		idx += 1
	end
end
def mSliceToken( prmSource )
	ary = []
	tokNow = false
	tokOld = false
	idxNow = 0
	idxOld = 0
	while idxNow < prmSource.size()
		chr = prmSource[idxNow]
		tokNow = ((0x30 <= chr and chr <= 0x39) or
				(0x41 <= chr and chr <= 0x5a) or
				(0x61 <= chr and chr <= 0x7a) or (chr == 0x5f))
		if tokNow != tokOld or tokNow == false
			if idxOld < idxNow
				ary << prmSource[idxOld...idxNow]
			end
			tokOld = tokNow
			idxOld = idxNow
		end
		idxNow += 1
	end
	if idxOld < idxNow
		ary << prmSource[idxOld...idxNow]
	end
	return ary
end
def mSliceTokenIgnoreBlank( prmSource )
	ary = []
	mSliceToken( prmSource ).each() do |str|
		if str[0] != 0x20
			ary << str
		end
	end
	return ary
end
def mNextIgnoreBlank( prmSlice, prmIndex )
	idx = prmIndex
	while idx < prmSlice.size()
		if prmSlice[idx][0] != 0x20
			return idx
		end
	end
	return -1
end
def mJoinIgnoreBlank( prmSlice, prmStart = 0 )
	ary = []
	prmSlice.each_with_index() do |str,idx|
		if prmStart <= idx
			str = mTrimBlank( str )
			if str[0] != 0x20 and str[0] != 0x5b and str[0] != 0x5d
				ary << str
			end
		end
	end
	return ary.join('')
end
def mLastZenHan( prmSource )
	zen = false
	idx = 0
	while idx < prmSource.size()
		if prmSource[idx] < 0x0080
			zen = false
		else
			idx += 1
			if idx >= prmSource.size()
				STDERR.puts('ill-kanji-broken-last')
				exit
			end
			if prmSource[idx] < 0x40
				STDERR.puts('ill-kanji-unknown-last')
				exit
			end
			zen = true
		end
		idx += 1
	end
	return zen
end
def mJoinZenHan( prmSlice )
	ary = []
	prmSlice.each() do |val|
		if ary.size() >= 1
			zenTail = mLastZenHan( ary[-1] )
			zenHead = (val[0] >= 0x0080)
			if not (zenTail or zenHead)
				ary << ' '
			end
		end
		ary << val
	end
	return ary.join('')
end
def mEscapeHtml( prmSource )
	msg = prmSource.gsub( '&', '&amp;' )
	tmp =       msg.gsub( '<', '&lt;'  )
	return      tmp.gsub( '>', '&gt;'  )
end
def mHtmlEscape( prmSlice )
	ary = []
	prmSlice.each() do |val|
		ary << mEscapeHtml( val )
	end
	return ary
end
def mSliceZenHan( prmSource )
	subsource = prmSource.gsub( 'fullwidth_colon', 'F' )
	trimblank = mTrimBlank( subsource )
	linkslice = mLinkSlice( trimblank )
	ret = []
	linkslice.each() do |str|
		zenhan = mZenHan( str )
		zenhan.each() do |zh|
			str = mTrimBlank( zh )
			if not str.empty?()
				ret << str
			end
		end
	end
	return ret
end
def mTrimBlank( prmSource )
	idx = 0
	while idx < prmSource.size()
		if prmSource[idx] != 0x20 and prmSource[idx] != 0x09 and
			prmSource[idx] != 0x0d and prmSource[idx] != 0x0a
			if prmSource[idx] != 0x81
				break
			end
			if (idx + 1) >= prmSource.size()
				STDERR.puts("ill-kanji")
				STDERR.puts("str=(" + prmSource + ')')
				raise
			end
			if prmSource[idx+1] != 0x40
				break
			end
			idx += 1
		end
		idx += 1
	end
	if idx >= prmSource.size()
		return ''
	end
	j = prmSource.size() - 1
	while j >= 0
		if prmSource[j] != 0x20 and prmSource[j] != 0x09 and
			prmSource[j] != 0x0d and prmSource[j] != 0x0a
			if j < 1
				break
			end
			if prmSource[j-1] != 0x81 or prmSource[j] != 0x40
				break
			end
			j -= 1
		end
		j -= 1
	end
	if j < 0
		STDERR.puts('error fatal')
		exit
	end
	return prmSource[idx..j]
end
def mLinkSlice( prmSource )
	k = 0
	linkslice = []
	while k < prmSource.size()
		i = prmSource.index( '@(', k )
		if not i
			linkslice << prmSource[k..-1]
			break
		end
		if k < i
			linkslice << prmSource[k...i]
		end
		linkslice << '@('
		i += 2
		j = prmSource.index( '@', i )
		if not j
			STDERR.puts('link error @')
			exit
		end
		if i >= j
			STDERR.puts('link error i=j')
			exit
		end
		linkslice << prmSource[i...j] << '@(@'
		j += 1
		k = prmSource.index( '@)', j )
		if not k
			STDERR.puts('link error @)')
			exit
		end
		if j >= k
			STDERR.puts('link error j=k')
			exit
		end
		linkslice << prmSource[j...k] << '@(@)'
		k += 2
	end
	return linkslice
end
def mZenHan( prmSource )
	ary = []
	zenNow = false
	zenOld = false
	idxNow = 0
	idxOld = 0
	while idxNow < prmSource.size()
		zenNow = (prmSource[idxNow] >= 0x0080)
		if zenNow != zenOld
			if idxOld < idxNow
				ary << prmSource[idxOld...idxNow]
			end
			zenOld = zenNow
			idxOld = idxNow
		end
		if zenNow
			idxNow += 1
			if idxNow >= prmSource.size()
				STDERR.puts('ill-kanji-broken')
				exit
			end
			if prmSource[idxNow] < 0x40
				STDERR.puts('ill-kanji-unknown')
				exit
			end
		end
		idxNow += 1
	end
	if idxOld < idxNow
		ary << prmSource[idxOld...idxNow]
	end
	return ary
end
def mNextLineIgnoreEmpty( prmLines, prmIndex )
	idx = prmIndex
	while idx < prmLines.size()
		str = mTrimBlank( prmLines[idx] )
		if str.size() >= 1
			return idx
		end
		idx += 1
	end
	return -1
end
def mPutHeader( prmClassName )
	print <<"EOF"
<html lang=ja>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=shift_jis">
<title> YKLook  NX  #{prmClassName} </title>
</head>




<!--  
                    ێS҂ւ̓`

                    ̃t@C𒼐ڕҏW_I@ij
  -->





<body bgcolor="#ffffff">
<table width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr>
    <td>
      <a href="../index.html"> YKLook </a> 
      <a href="index.html"> NX </a> 
      <a name="top"> #{prmClassName} </a>
    </td>
    <td align=right>
      <a href="cla-list-func.html" title="#{YK_FUNCDSP}"> #{YK_FUNC} </a>
      <!-- kanji sp --> @ <!-- kanji sp -->
      <a href="cla-list-abc.html" title="NXꗗi`abj"> `ab </a>
    </td>
  </tr>
</table>
EOF
end
def mPutLinkBar( prmHash )
	cm = prmHash[':class']
	im = prmHash[':instance']
	mm = prmHash[':misc']
	if (cm.size() + im.size() + mm.size()) < 1
		lm1 = ''
		lm2 = ''
	else
		lm1 = '<a href="#link-list"> '
		lm2 = ' </a>'
	end
	sm1 = '<a href="#link-super"> '
	sm2 = ' </a>'
	if cm.size() < 1
		cm1 = ''
		cm2 = ''
	else
		cm1 = '<a href="#link-class"> '
		cm2 = ' </a>'
	end
	if im.size() < 1
		im1 = ''
		im2 = ''
	else
		im1 = '<a href="#link-instance"> '
		im2 = ' </a>'
	end
	if mm.size() < 1
		mm1 = ''
		mm2 = ''
	else
		mm1 = '<a href="#link-misc"> '
		mm2 = ' </a>'
	end
	print <<"EOF"
<table bgcolor="#ccffcc" width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr nowrap>
    <td>
      #{lm1} #{YK_LIST} #{lm2}
      <!-- kanji sp --> @ <!-- kanji sp -->
      #{sm1} #{YK_SUPER} #{sm2}
      <!-- kanji sp --> @ <!-- kanji sp -->
      #{cm1} #{YK_CLASS} #{cm2}
      <!-- kanji sp --> @ <!-- kanji sp -->
      #{im1} #{YK_INST} #{im2}
      <!-- kanji sp --> @ <!-- kanji sp -->
      #{mm1} #{YK_MISC} #{mm2}
    </td>
    <td> &nbsp; </td>
  </tr>
</table>
EOF
end

def mPutFooter( prmClassName )
	print <<"EOF"
<table width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr>
    <td>
      <a href="../index.html"> YKLook </a> 
      <a href="index.html"> NX </a> 
      <a href="#top" title="̃y[W̐擪"> #{prmClassName} </a>
    </td>
    <td align=right>
      <a href="cla-list-func.html" title="#{YK_FUNCDSP}"> #{YK_FUNC} </a>
      <!-- kanji sp --> @ <!-- kanji sp -->
      <a href="cla-list-abc.html" title="NXꗗi`abj"> `ab </a>
    </td>
  </tr>
</table>
<br>
<hr>
<center>
  <span title="iLj낸Ƃ">
    Copyright (c) 2003-2010 YorozuKotowariYa Ltd.
  </span>
</center>

<!-- 

Copyright (c) 2003-2010 YorozuKotowariYa Ltd.
iLj낸Ƃ

designed by Hatashima Koji
written by Hatashima Koji
݌vF_
F_

 -->

</body>
</html>
EOF
end
def mPutSubTitle( prmLinkLabel, prmDisplayLabel )
	print <<"EOF"
<br />
<table bgcolor="#dddddd" width="100%" cellpadding=4>
<tr><td id="#{prmLinkLabel}"> #{prmDisplayLabel} </td></tr>
</table>
EOF
end
def mPutLinkList( prmLinkHash )
	msg = mMakeLinkList( prmLinkHash[':class'], prmLinkHash )
	puts( YK_CLASS_C + "\n" + msg + "<br />" )
	msg = mMakeLinkList( prmLinkHash[':instance'], prmLinkHash )
	puts( YK_INST_C + "\n" + msg + "<br />" )
	msg = mMakeLinkList( prmLinkHash[':misc'], prmLinkHash )
	puts( YK_MISC_C + "\n" + msg + "<br />\n<br />" )
end
def mMakeLinkList( prmList, prmLinkHash )
	if prmList.size() < 1
		return 'Ȃ'
	end
	ary = []
	prmList.each() do |str|
		if str[0] == 0x40
			r = str[1..-1]
			m = prmLinkHash[str]
		else
			i = str.index('(')
			if not i
				STDERR.puts('ill-fmt method args')
				exit
			end
			r = prmLinkHash[str]
			m = str[1...i]
		end
		ary << ' &nbsp; <a href="#' << r << '"> ' << m << " </a>\n"
	end
	return ary.join('')
end
def mPutSuperClass( prmClassName, prmLines )
	puts('<pre>')
	prmLines.each() do |str|
		if str[0] != 0x0d and str[0] != 0x0a
			if str[0] != 0x81 or str[1] != 0x40
				STDERR.puts('ill-fmt super class space')
				exit
			end
			i = str.index('YKLook')
			if i
				pre = str[0...i]
				j = i + 6
				while j < str.size()
					chr = str[j]
					if (chr < 0x41) or
						(0x5a < chr and chr < 0x61) or (0x7a < chr)
						break
					end
					j += 1
				end
				if j >= str.size()
					STDERR.puts('ill-fmt broken newline')
					exit
				end
				cls = str[i...j]
				pst = str[j..-1]
				if cls != prmClassName
					str = pre + '<a href="cla-' + cls + '.html">' +
							cls + '</a>' + pst
				end
			end
			puts( str )
		end
	end
	puts('</pre>')
end
def mFindAvailableChar( prmString )
	idx = 0
	while idx < prmString.size()
		if prmString[idx] != 0x09 and prmString[idx] != 0x20
			if (idx + 1) >= prmString.size()
				return idx
			end
			if prmString[idx] != 0x81 or prmString[idx+1] != 0x40
				return idx
			end
			idx += 1
		end
		idx += 1
	end
	STDERR.puts('ill-fmt TAB only')
	exit
end
def mUl( prmClassName, prmLines, prmIndex, prmMark, prmBuf,
			prmVarList, prmLinkHash )
	ary = []
	idx = mGetBlock( prmLines, prmIndex, prmMark, ['E','@'], ary )
	prmBuf << "<ul>\n"
	pos = 0
	while pos < ary.size()
		wrk = []
		pos = mGetItems( ary, pos, prmMark, 'E', 'E', wrk )
		wrk[0][prmMark,2] = '@'
		prmBuf << "<li>\n"
		prmBuf << mMakeMethodOne( prmClassName, wrk, prmVarList, prmLinkHash )
		prmBuf << "</li>\n"
	end
	prmBuf << "</ul>\n"
	return idx
end
def mDigit( prmClassName, prmLines, prmIndex, prmMark, prmBuf,
			prmVarList, prmLinkHash )
	ary = []
	idx = mGetBlock( prmLines, prmIndex, prmMark, ['i','@'], ary )
	prmBuf << "<table border=0 cellpadding=0 cellspacing=0>\n"
	pos = 0
	while pos < ary.size()
		wrk = []
		pos = mGetItems( ary, pos, prmMark, 'i', 'i', wrk )
		tmp = wrk[0].index('j')
		if not tmp
			STDERR.puts('ill-fmt at mDigit')
			exit
		end
		dig = wrk[0][prmMark..(tmp+1)]
		wrk[0][prmMark..(tmp+1)] = '@@@'
		prmBuf << "<tr> <td valign=top> #{dig} </td>\n<td>\n"
		prmBuf << mMakeMethodOne( prmClassName, wrk, prmVarList, prmLinkHash )
		prmBuf << "</td>\n</tr>\n"
	end
	prmBuf << "</table>\n"
	return idx
end
def mCaution( prmClassName, prmLines, prmIndex, prmMark, prmBuf,
				prmVarList, prmLinkHash )
	ary = [ prmLines[prmIndex] ]
	idx = mGetBlock( prmLines, prmIndex + 1, prmMark, ['@'], ary )
	pos = ary[0].index('F')
	if not pos
		STDERR.puts('ill-fmt at mCaution')
		exit
	end
	cau = ary[0][prmMark..(pos+1)]
	ary[0][prmMark..(pos+1)] = '@@@'
	prmBuf << "<table border=0 cellpadding=0 cellspacing=0>\n"
	prmBuf << "<tr> <td valign=top nowrap> #{cau} </td>\n<td>\n"
	prmBuf << mMakeMethodOne( prmClassName, ary, prmVarList, prmLinkHash )
	prmBuf << "</td>\n</tr>\n</table>\n"
	return idx
end
def mJava( prmLines, prmIndex, prmMark, prmBuf )
	ary = [ prmLines[prmIndex] ]
	idx = mGetBlock( prmLines, prmIndex + 1, prmMark, ['@'], ary )
	pos = ary[0].index('F')
	if not pos
		STDERR.puts('ill-fmt at mJava')
		exit
	end
	jav = ary[0][prmMark..(pos-1)]
	ary[0][prmMark..(pos+1)] = '@@@'
	prmBuf << "<table border=1 cellspacing=0 cellpadding=6>\n"
	# prmBuf << "<table border=1 cellpadding=6>\n"
	prmBuf << "<tr> <td valign=top> #{jav} </td>\n<td>\n"
	prmBuf << mMakeMethodOne( 'YKLook', ary, [], { } )
	prmBuf << "</td>\n</tr>\n</table>\n"
	return idx
end
def mCheckKeyVal( prmLines, prmIndex, prmMark, prmKeyVal )
	idx = prmIndex
	str = prmLines[idx][prmMark..-1]
	key = str.split('F')[0]
	prmKeyVal << (key + 'F')
	if key.index('')
		return false
	end
	idx += 1
	if idx >= prmLines.size()
		return false
	end
	if not mCheckTabMark( prmLines[idx], prmMark )
		return false
	end
	str = prmLines[idx][prmMark..-1]
	if not str.split('').index('F')
		return false
	end
	val = str.split('F')[0]
	prmKeyVal << (val + 'F')
	if key == val
		return false
	end
	idx += 1
	while idx < prmLines.size()
		str = prmLines[idx]
		if str.size() <= (prmMark + 1)
			return false
		end
		if not mCheckTabMark( str, prmMark )
			return false
		end
		if str[prmMark] != 0x81 or str[prmMark+1] != 0x40
			break
		end
		idx += 1
	end
	if idx >= prmLines.size()
		return true
	end
	if not mCheckTabMark( prmLines[idx], prmMark )
		return false
	end
	str = prmLines[idx][prmMark..-1]
	if not str.split('').index('F')
		return false
	end
	return (str.split('F')[0] == key)
end
def mKeyVal( prmClassName, prmLines, prmIndex, prmMark, prmKeyVal, prmBuf,
									prmVarList, prmLinkHash )
	hdr = ['@'] + prmKeyVal
	ary = []
	idx = mGetBlock( prmLines, prmIndex, prmMark, hdr, ary )
	th0 = mCutTail( prmKeyVal[0], 'F' )
	th1 = mCutTail( prmKeyVal[1], 'F' )
	prmBuf << "<table border=1 cellpadding=6>\n<tr>\n"
	prmBuf << "    <th nowrap> #{th0} </th>\n"
	prmBuf << "    <th> #{th1} </th>\n</tr>\n"
	pos = 0
	while pos < ary.size()
		tmp = ary[pos].index('F')
		if not tmp
			STDERR.puts('ill-fmt key at mKeyVal')
			exit
		end
		key = mKeyTtBr( ary[pos][(tmp+2)..-1] )
		prmBuf << "<tr>\n<td nowrap> #{key} </td>\n"
		wrk = []
		pos = mGetItems( ary, pos+1, prmMark, prmKeyVal[1], prmKeyVal[0], wrk )
		tmp = wrk[0].index('F')
		if not tmp
			STDERR.puts('ill-fmt val at mKeyVal')
			exit
		end
		wrk[0][prmMark..(tmp+1)] = '@@@'
		prmBuf << "<td>\n"
		prmBuf << mMakeMethodOne( prmClassName, wrk, prmVarList, prmLinkHash )
		prmBuf << "</td>\n</tr>\n"
	end
	prmBuf << "</table>\n"
	return idx
end
def mKeyTtBr( prmString )
	slice = mZenHan( mTrimBlank( prmString ) )
	ary = []
	slice.each() do |str|
		key = mTrimBlank( str )
		if key.size() <= 0
			key = "<br />\n"
		else
			if key[0] <= 0x7f
				wrk = []
				mSliceToken( key ).each() do |str|
					if str[0] == 0x20
						wrk << ' <br /> '
					else
						wrk << str
					end
				end
				key = '<tt> ' + wrk.join('') + ' </tt>'
			end
		end
		ary << key
	end
	return mJoinZenHan( ary )
end
def mCutTail( prmSource, prmTail )
	ss = prmSource.size()
	ts = prmTail.size()
	ds = ss - ts
	if ds <= 0
		STDERR.puts('ill-fmt size at mCutTail')
		exit
	end
	if prmSource[ds,ts] != prmTail
		STDERR.puts('ill-fmt unmatch at mCutTail')
		exit
	end
	return prmSource[0,ds]
end
def mExample( prmLines, prmIndex, prmMark, prmBuf )
	ary = []
	idx = mGetBox( prmLines, prmIndex, 'F', ary )
	prmBuf << "<table border=1 cellspacing=0 cellpadding=12>\n"
	pos = 0
	while pos < ary.size()
		tmp = ary[pos].index('F')
		if not tmp
			STDERR.puts('ill-fmt key at mExample')
			exit
		end
		exa = ary[pos][prmMark..(tmp+1)]
		wrk = []
		pos = mGetBox( ary, pos, [exa], wrk )
		prmBuf << "<tr>\n<td nowrap> #{exa[0..-3]} </td>\n"
		prmBuf << "<td> <pre>\n"
		wrk.each() do |str|
			prmBuf << mEscapeHtml( str[(tmp+2)..-1] )
		end
		prmBuf << "</pre> </td>\n</tr>\n"
	end
	prmBuf << "</table>\n"
	return idx
end
def mGetItems( prmLines, prmIndex, prmMark, prmStart, prmEnd, prmResults )
	if prmLines.nil?()
		STDERR.puts('prmLines nil')
		STDERR.puts('prmStart=(' + prmStart.to_s() + ')')
		STDERR.puts('prmEnd=(' + prmEnd.to_s() + ')')
		exit
	end
	if prmLines[prmIndex].nil?()
		STDERR.puts('prmLines[prmIndex] nil')
		STDERR.puts('prmStart=(' + prmStart.to_s() + ')')
		STDERR.puts('prmEnd=(' + prmEnd.to_s() + ')')
		raise
	end
	siz = prmStart.size()
	if prmLines[prmIndex][prmMark,siz] != prmStart
		STDERR.puts('ill-fmt at mGetItems')
		exit
	end
	prmResults << prmLines[prmIndex]
	siz = prmEnd.size()
	idx = prmIndex + 1
	while idx < prmLines.size()
		str = prmLines[idx]
		if str[prmMark,siz] == prmEnd
			break
		end
		prmResults << str
		idx += 1
	end
	return idx
end
def mGetBox( prmLines, prmIndex, prmTarget, prmResults )
	idx = prmIndex
	while idx < prmLines.size()
		str = prmLines[idx]
		if prmTarget.kind_of?(Array)
			if not str.index( prmTarget[0] )
				break
			end
		else
			if not str.split('').index(prmTarget)
				break
			end
		end
		prmResults << str
		idx += 1
	end
	return idx
end
def mGetBlock( prmLines, prmIndex, prmMark, prmHeads, prmResults )
	idx = prmIndex
	while idx < prmLines.size()
		str = prmLines[idx]
		if not mCheckTabMark( str, prmMark )
			break
		end
		if not mCheckHeadMark( str, prmMark, prmHeads )
			break
		end
		prmResults << str
		idx += 1
	end
	return idx
end
def mCheckTabMark( prmString, prmMark )
	if prmString.size() <= prmMark
		return false
	end
	idx = 0
	while idx < prmMark
		if prmString[idx] != 0x09 and prmString[idx] != 0x20
			idx += 1
			if prmString.size() <= idx or prmMark <= idx
				return false
			end
			if prmString[idx-1] != 0x81 or prmString[idx] != 0x40
				return false
			end
		end
		idx += 1
	end
	return true
end
def mCheckHeadMark( prmString, prmMark, prmHeads )
	prmHeads.each() do |obj|
		if (prmMark + obj.size()) <= prmString.size()
			if prmString[prmMark,obj.size()] == obj
				return true
			end
		end
	end
	return false
end
def mMakeMethodOne( prmClassName, prmLines, prmVarList, prmLinkHash )
	buf = []
	idx = 0
	while idx < prmLines.size()
		str = prmLines[idx]
		while true
			if str[0] == 0x0d or str[0] == 0x0a
				buf << "<br />\n"
				idx += 1
				break
			end
			mrk = mFindAvailableChar( str )
			if str[mrk,2] == 'E'
				idx = mUl( prmClassName, prmLines, idx, mrk, buf,
							prmVarList, prmLinkHash )
				break
			end
			if str[mrk,2] == 'i'
				if '0123456789'.index(str[mrk+2,1]) or
					YK_DIGIT.include?(str[mrk+2,2])
					idx = mDigit( prmClassName, prmLines, idx, mrk, buf,
									prmVarList, prmLinkHash )
					break
				end
			end
			ary = str[mrk..-1].split('')
			if ary.index('F') and not str.index("F\n")
				if str[mrk,6] == 'ӁF' or str[mrk,6] == '⑫F'
					idx = mCaution( prmClassName, prmLines, idx, mrk, buf,
									prmVarList, prmLinkHash )
					break
				end
				if str[mrk,6] == 'JavaF'
					idx = mJava( prmLines, idx, mrk, buf )
					break
				end
				ary = []
				if mCheckKeyVal( prmLines, idx, mrk, ary )
					idx = mKeyVal( prmClassName, prmLines, idx, mrk, ary, buf,
									prmVarList, prmLinkHash )
					break
				end
				idx = mExample( prmLines, idx, mrk, buf )
				break
			end
			slice = mSliceZenHan( str )
			buf << mMakeCodeVarTtLink( prmClassName, slice,
										prmVarList, prmLinkHash )
			buf << mMakeBrIfNeed( str )
			idx += 1
			break
		end
		# idx += 1
	end
	return buf.join('')
end
def mPutMethodOne( prmClassName, prmLines, prmVarList, prmLinkHash )
	while 0 < prmLines.size()
		chr = prmLines[0][0]
		if chr != 0x0d and chr != 0x0a
			break
		end
		prmLines.delete_at(0)
	end
	idx = prmLines.size() - 1
	while idx >= 0
		chr = prmLines[idx][0]
		if chr != 0x0d and chr != 0x0a
			break
		end
		prmLines.delete_at(idx)
		idx -= 1
	end
	if prmLines.size() >= 1
		puts( '<div style="margin-left: 40px">' )
		puts( mMakeMethodOne( prmClassName, prmLines, prmVarList, prmLinkHash ))
		puts( '</div>' )
		puts( '<br />' )
	end
end
def mPutMethodAll( prmClassName, prmLines, prmLinkHash, prmCI, prmKeyMark )
	varList = []
	methodName = nil
	afterLabel = nil
	cnt = 0
	idx = 0
	while true
		idx = mNextLineIgnoreEmpty( prmLines, idx )
		if idx < 0
			break
		end
		lin = prmLines[idx]
		if lin[0] == 0x09
			if methodName
				puts('<br />')
			end
			ary = []
			idx = mGetGroup( prmLines, idx, ary )
			mPutMethodOne( prmClassName, ary, varList, prmLinkHash )
			varList = []
			methodName = nil
		else
			if lin[0] == 0x40
				if afterLabel
					STDERR.puts('illegal label format')
					exit
				end
				afterLabel = mMakeLabel( lin, prmLinkHash )
			else
				if (cnt + 1) < idx  # and cnt > 0
					puts("<br />\n<hr>\n<br />\n")
				end
				cnt = idx

				if prmCI
					if 0x30 <= lin[0] and lin[0] <= 0x39
						j = lin.index(' ')
						if not j
							STDERR.puts('illegal num format')
							exit
						end
						num = lin[0...j]
						str = lin[(j+1)..-1]
						if not methodName
							methodName = mPickupMethodName( str,
													prmLinkHash, prmKeyMark )
							a = 'Ăяo`[' +(num == '0' ? 'Tv' : num)+ ']'
							b = '<a name="' + prmCI + '-' + methodName +
								'-' + num + '"> ' + a + ' </a>'
							puts( b )
							puts( (afterLabel ? afterLabel : '') + ' <br />')
							afterLabel = nil
						end
					else
						str = lin
						if not methodName
							methodName = mPickupMethodName( str,
													prmLinkHash, prmKeyMark )
							b = '<a name="' + prmCI + '-' + methodName +
								'-1"> &nbsp; </a>'
							if afterLabel
								afterLabel = afterLabel + ' ' + b
							else
								afterLabel = b
							end
						end
					end
					res = mMakeMethodString( str, varList )
				else
					methodName = lin
					slice = mSliceZenHan( lin )
					res = mMakeCodeVarTtLink( prmClassName, slice,
												[], prmLinkHash )
				end
				puts( res + (afterLabel ? afterLabel : '') + ' <br />')
				afterLabel = nil
			end
			idx += 1
		end
		if idx < 0
			break
		end
	end
end
def mMakeLabel( prmLine, prmLinkHash )
	if prmLine[0..1] != '@('
		STDERR.puts('illegal label format 1')
		exit
	end
	i = prmLine.index(')')
	if not i
		STDERR.puts('illegal label format 2')
		exit
	end
	label = prmLine[2...i]
	if not prmLinkHash[('@' + label)]
		STDERR.puts('unknown label 3')
		exit
	end
	return (' <a name="' + label + '"> &nbsp; </a>')
end
def mPickupMethodName( prmString, prmLinkHash, prmKeyMark )
	i = prmString.index('(')
	if not i
		STDERR.puts('unknown var at pickup')
		exit
	end
	str = prmString[0...i]
	if not prmLinkHash[ (prmKeyMark + str) ]
		STDERR.puts('unknown hash at pickup')
		STDERR.puts('prmString=(' + prmString + ')')
		STDERR.puts('prmKeyMark=(' + prmKeyMark + ')(' + str + ')')
		exit
	end
	return str
end
def mMakeMethodString( prmString, prmVarList )
	tokens = mSliceToken( mTrimBlank( prmString ) )
	flg = 0
	idx = 1
	while idx < tokens.size()
		if tokens[idx] == "'"
			flg = ((flg + 1) % 2)
		else
			if flg == 0
				chr = tokens[idx][0]
				if 0x61 <= chr and chr <= 0x7a
					if not prmVarList.include?( tokens[idx] )
						prmVarList << tokens[idx]
					end
				end
			end
		end
		idx += 1
	end
	mVar( tokens, prmVarList )
	return ('<code> ' + tokens.join('') + ' </code>')
end
def mGetWorld( prmLines, prmStart, prmResult )
	idx = prmStart
	while idx < prmLines.size()
		chr = prmLines[idx][0]
		if chr != 0x20 and chr != 0x09 and chr != 0x0d and chr != 0x0a
			if mTrimBlank( prmLines[idx] )[-2..-1] == 'F'
				return idx
			end
		end
		prmResult << prmLines[idx]
		idx += 1
	end
	return -1
end
def mGetGroup( prmLines, prmStart, prmResult )
	idx = prmStart
	while idx < prmLines.size()
		chr = prmLines[idx][0]
		if chr != 0x09 and chr != 0x0d and chr != 0x0a
			return idx
		end
		prmResult << prmLines[idx]
		idx += 1
	end
	return -1
end


#
# main
#
classBody = File.basename( ARGV[0], '.txt' )
if classBody[0..3] == 'man-'
	classBody = classBody[4..-1]
end
className = 'YKLook' + classBody
lines = File.readlines( ARGV[0] )
mDeleteTrail( lines )
hash = mScan( lines )
mPutHeader( className )
mPutLinkBar( hash )

idx = mNextLineIgnoreEmpty( lines, 0 )
if mTrimBlank( lines[idx] ) != className
	STDERR.puts('ill class name')
	exit
end

puts("<br />")
puts("<h1> #{className} </h1>")
puts("<br />")

ary = []
idx = mGetWorld( lines, idx + 1, ary )
if ary.size() < 1 or idx < 0
	STDERR.puts('ill class description')
	exit
end
if mTrimBlank( lines[idx] ) != YK_SUPER_C
	STDERR.puts('ill item name, superclass')
	exit
end
mPutMethodOne( className, ary, [], hash )
puts("<br />")

mPutSubTitle( 'link-list', YK_LIST )
puts("<br />")
mPutLinkList( hash )

ary = []
idx = mGetWorld( lines, idx + 1, ary )
if ary.size() < 1 or idx < 0
	STDERR.puts('ill superclass description')
	exit
end
if mTrimBlank( lines[idx] ) != YK_CLASS_C
	STDERR.puts('ill item name, classmethod')
	exit
end
mPutSubTitle( 'link-super', YK_SUPER )
mPutSuperClass( className, ary )

ary = []
idx = mGetWorld( lines, idx + 1, ary )
if ary.size() < 1 or idx < 0
	STDERR.puts('ill classmethod description')
	exit
end
if mTrimBlank( lines[idx] ) != YK_INST_C
	STDERR.puts('ill item name, instancemethod')
	exit
end
mPutSubTitle( 'link-class', YK_CLASS )
puts("<br />")
mPutMethodAll( className, ary, hash, 'c', '.' )

ary = []
idx = mGetWorld( lines, idx + 1, ary )
if ary.size() < 1
	STDERR.puts('ill instancemethod description')
	exit
end
if idx > 0
	if mTrimBlank( lines[idx] ) != YK_MISC_C
		STDERR.puts('ill item name, misc')
		exit
	end
end
mPutSubTitle( 'link-instance', YK_INST )
puts("<br />")
mPutMethodAll( className, ary, hash, 'i', '#' )

mPutSubTitle( 'link-misc', YK_MISC )
puts("<br />")
if idx > 0
	ary = []
	idx = mGetWorld( lines, idx + 1, ary )
	if ary.size() < 1
		STDERR.puts('ill misc description')
		exit
	end
	if idx > 0
		STDERR.puts('ill item name, unknown')
		exit
	end
	mPutMethodAll( className, ary, hash, nil, '@' )
else
	puts('<div style="margin-left: 40px">')
	puts('Ȃ')
	puts('</div> <br />')
end

puts("<br />")
puts("<br />")
mPutLinkBar( hash )
mPutFooter( className )


# hash.each() do |key,val|
# 	if val.kind_of?(Array)
# 		puts( "key=(" + key + ")-------------------------------------------" )
# 		val.each_with_index() do |obj,idx|
# 			puts( "val=(" + key + ") [" + idx.to_s() + "]=(" + obj + ")" )
# 		end
# 		puts( "end=(" + key + ")-------------------------------------------" )
# 	else
# 		puts( "key=(" + key + ")\nval=(" + val + ")" )
# 	end
# end

# lines.each() do |line|
# 	puts( "==(==" + mSliceToken( line ).join('/') + "==)==" )
# end



#
# end
